# ufpsutil

Unix File Permission Supplicant Utility - A simple utility that indexes directories and records their Unix permission and ownership data.

## Purpose
The purpose of this project is to recursively delve into subdirectories and record their Unix file permissions and ownership information.

Most offsite backup solutions (such as Backblaze) don't store file permissions or ownership information. This means that in the event that data needs to be restored from them, time will need to be taken in order to update permissions and owners, which adds additional downtime.

Naturally, enterprises have solutions to this, but self hosters may not. This project aims to remedy that.

The idea is to record all of this information to a text file, which is backed up off-site as a normal file. This file can then be read by the utility to restore permissions, thereby making the restored backup as close as possible to how it was before it crashed. If mounted to the same locations, this solves any permissions issues a self hoster could face getting back up and running after a catastrophe.

## Status
- ❎ Recurse a directory (index)
- ❎ Store Unix file permissions and ownership data
- ❎ Restore Unix file permissions and ownership data using index file as an input
- ❎ Diff index file and restored backup and inform the user of file inconsistencies 
- ❎ Index file encryption with bcrypt